function CopyLines(Sender, direction) {
    var userSelection = Editor.Selection;
    if ((userSelection.SelStartLine >= 0) && (userSelection.SelEndLine >= 0)) {
        Editor.BeginEditing;

        var startLine = userSelection.SelStartLine;
        var endLine = userSelection.SelEndLine;
        if ((endLine > startLine) && (userSelection.SelEndCol == 0)) {
            endLine--;
        }

        var line;
        var s = "";
        for (var i = startLine; i <= endLine; i++) {
          line = Editor.Lines[i];
          s += line + "\n";
        }

        if (direction == "down") {
            if (endLine == (Editor.LineCount - 1)) {
                s = "\n" + s;
            }
            userSelection.SelStartLine = endLine + 1;
        }
        if (direction == "up") {
            userSelection.SelStartLine = startLine;
        }
        userSelection.SelStartCol = 0;
        userSelection.SelEndLine = userSelection.SelStartLine;
        userSelection.SelEndCol = 0;

        Editor.Selection = userSelection;
        Editor.SelText = s;

        Editor.EndEditing;
    }
}

function CopyLinesDown(Sender) {
    CopyLines(Sender, "down");
}

function CopyLinesUp(Sender) {
    CopyLines(Sender, "up");
}

Script.RegisterDocumentAction("Coding", "Copy lines down", "Shift+Ctrl+Down", &CopyLinesDown);
Script.RegisterDocumentAction("Coding", "Copy lines up", "Shift+Ctrl+Up", &CopyLinesUp);